87 lines
3.0 KiB
Diff
87 lines
3.0 KiB
Diff
|
From 822439e4eaa4bb758d9058022154973cd690eca7 Mon Sep 17 00:00:00 2001
|
||
|
From: "Brian C. Lane" <bcl@redhat.com>
|
||
|
Date: Fri, 5 Jun 2015 13:46:29 -0700
|
||
|
Subject: [PATCH] tests: Make sure the extended partition length is correct
|
||
|
(#1135493)
|
||
|
|
||
|
parted tells the kernel the wrong length when reporting a resize of an
|
||
|
extended partition. Make sure the length is 2 for 512b sectors and 1
|
||
|
sector for larger.
|
||
|
|
||
|
(cherry picked from commit 31b5bfa4cd0b2e2944af22466e7b7d88ad94c4c9)
|
||
|
---
|
||
|
tests/Makefile.am | 1 +
|
||
|
tests/t2320-dos-extended-noclobber.sh | 48 +++++++++++++++++++++++++++++++++++
|
||
|
2 files changed, 49 insertions(+)
|
||
|
create mode 100644 tests/t2320-dos-extended-noclobber.sh
|
||
|
|
||
|
diff --git a/tests/Makefile.am b/tests/Makefile.am
|
||
|
index ce8391d..001b9de 100644
|
||
|
--- a/tests/Makefile.am
|
||
|
+++ b/tests/Makefile.am
|
||
|
@@ -47,6 +47,7 @@ TESTS = \
|
||
|
t2201-pc98-label-recog.sh \
|
||
|
t2300-dos-label-extended-bootcode.sh \
|
||
|
t2310-dos-extended-2-sector-min-offset.sh \
|
||
|
+ t2320-dos-extended-noclobber.sh \
|
||
|
t2400-dos-hfs-partition-type.sh \
|
||
|
t2500-probe-corrupt-hfs.sh \
|
||
|
t3000-resize-fs.sh \
|
||
|
diff --git a/tests/t2320-dos-extended-noclobber.sh b/tests/t2320-dos-extended-noclobber.sh
|
||
|
new file mode 100644
|
||
|
index 0000000..6f3dfff
|
||
|
--- /dev/null
|
||
|
+++ b/tests/t2320-dos-extended-noclobber.sh
|
||
|
@@ -0,0 +1,48 @@
|
||
|
+#!/bin/sh
|
||
|
+# Ensure that the extended partition reports the correct length
|
||
|
+# after adding another partition.
|
||
|
+
|
||
|
+# Copyright (C) 2015 Free Software Foundation, Inc.
|
||
|
+
|
||
|
+# This program is free software; you can redistribute it and/or modify
|
||
|
+# it under the terms of the GNU General Public License as published by
|
||
|
+# the Free Software Foundation; either version 3 of the License, or
|
||
|
+# (at your option) any later version.
|
||
|
+
|
||
|
+# This program is distributed in the hope that it will be useful,
|
||
|
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
||
|
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
||
|
+# GNU General Public License for more details.
|
||
|
+
|
||
|
+# You should have received a copy of the GNU General Public License
|
||
|
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
||
|
+
|
||
|
+. "${srcdir=.}/init.sh"; path_prepend_ ../parted
|
||
|
+
|
||
|
+require_root_
|
||
|
+require_scsi_debug_module_
|
||
|
+
|
||
|
+# create memory-backed device
|
||
|
+ss=$sector_size_
|
||
|
+scsi_debug_setup_ sector_size=$ss dev_size_mb=10 > dev-name ||
|
||
|
+ skip_ 'failed to create scsi_debug device'
|
||
|
+scsi_dev=$(cat dev-name)
|
||
|
+
|
||
|
+# Create a DOS label with an extended partition and a primary partition
|
||
|
+parted -s $scsi_dev mklabel msdos || fail=1
|
||
|
+parted -s $scsi_dev mkpart extended 1 5 > out 2>&1 || fail=1
|
||
|
+parted -s $scsi_dev mkpart primary 5 10 > out 2>&1 || fail=1
|
||
|
+
|
||
|
+# Make sure the size of the extended partition is correct.
|
||
|
+# 2 sectors for 512b and 1 sector for larger. /sys/.../size is in
|
||
|
+# 512b blocks so convert accordingly.
|
||
|
+dev=${scsi_dev#/dev/}
|
||
|
+ext_len=$(cat /sys/block/$dev/${dev}1/size)
|
||
|
+if [ $ss -eq 512 ]; then
|
||
|
+ expected_len=2
|
||
|
+else
|
||
|
+ expected_len=$((ss / 512))
|
||
|
+fi
|
||
|
+[ $ext_len -eq $expected_len ] || fail=1
|
||
|
+
|
||
|
+Exit $fail
|
||
|
--
|
||
|
2.4.3
|
||
|
|